'use strict';

import { register } from "@systemorph/web";
import { IPromise, IHttpService } from 'angular';
import { IAccessReviewService } from "./accessControl.api";

class AccessReviewService implements IAccessReviewService {
    private readonly baseApiUrl: string = '/api/accessReviewUtils/';

    constructor(private $http: IHttpService) {
    }

    completeReview(reviewId: string, comment: string): IPromise<any> {
        return this.$http.post<any>(`${this.baseApiUrl}completeReview`, { reviewId, comment }, {})
                    .then(result => result.data)
                    .catch(result => {
                        throw result.data ? result.data.message : "";
                    });
    }

    notifyReviewCreated(reviewId: string): IPromise<any> {
        return this.$http.post<any>(`${this.baseApiUrl}notifyReviewCreated`, { reviewId }, {})
                    .then(result => result.data)
                    .catch(result => {
                        throw result.data ? result.data.message : "";
                    });
    }
}

register.service("accessReviewService", AccessReviewService)