'use strict';

import { register, ISmPanelRadioButtonOption } from '@systemorph/web';
import { AC_ASSIGNMENT_STATUS } from "../../accessControl.constants";

register.directive("assignmentStatusFilter", () => {
    return {
        restrict: 'E',
        replace: true,
        require: "ngModel",
        scope: true,
        controllerAs: 'asfCtrl',
        bindToController: {
            assignmentStatus: "=ngModel",
            onChange: "&"
        },
        template: `<div>
                    <sm-panel-radio-button-filter ng-model="asfCtrl.assignmentStatus" 
                                                  all-options="asfCtrl.allStatuses" 
                                                  on-change="asfCtrl.changeHandler()">
                    </sm-panel-radio-button-filter>
                  </div>`,
        controller: AssignmentStatusFilterController
    };
});

class AssignmentStatusFilterController {
    //binded
    assignmentStatus: string;
    onChange: () => void;

    allStatuses: ISmPanelRadioButtonOption<string>[];

    constructor() {
        this.allStatuses = [
            {
                value: null,
                displayName: "All"
            },
            {
                value: AC_ASSIGNMENT_STATUS.approved,
                displayName: AC_ASSIGNMENT_STATUS.approved
            },
            {
                value: AC_ASSIGNMENT_STATUS.requested,
                displayName: AC_ASSIGNMENT_STATUS.requested
            }
        ];
    }

    changeHandler() {
        if (this.onChange) {
            this.onChange();
        }
    }
}