'use strict';

import { register, ISmPanelRadioButtonOption } from '@systemorph/web';
import { AC_ASSIGNMENT_TYPE } from "../../accessControl.constants";

register.directive("assignmentTypeFilter", () => {
    return {
        restrict: 'E',
        replace: true,
        require: "ngModel",
        scope: true,
        controllerAs: 'atfCtrl',
        bindToController: {
            assignmentType: "=ngModel",
            onChange: "&"
        },
        template: `<div>
                        <sm-panel-radio-button-filter ng-model="atfCtrl.assignmentType"
                                                  all-options="atfCtrl.allAssignmentTypes" 
                                                  on-change="atfCtrl.changeHandler()">
                        </sm-panel-radio-button-filter>
                   </div>`,
        controller: AssignmentTypeFilterController
    };
});

class AssignmentTypeFilterController {
    //binded
    assignmentType: string;
    onChange: () => void;

    allAssignmentTypes: ISmPanelRadioButtonOption<string>[];

    constructor() {
        this.allAssignmentTypes = [
            {
                value: null,
                displayName: "All"
            },
            {
                value: AC_ASSIGNMENT_TYPE.member,
                displayName: AC_ASSIGNMENT_TYPE.member
            },
            {
                value: AC_ASSIGNMENT_TYPE.owner,
                displayName: AC_ASSIGNMENT_TYPE.owner
            }
        ];
    }

    changeHandler() {
        if (this.onChange) {
            this.onChange();
        }
    }
}