'use strict';

import { register, ISmPanelRadioButtonOption } from '@systemorph/web';
import { IGroupScopeFilterModel } from "./filterComponents.api";

register.directive("groupScopeFilter", () => {
    return {
        restrict: 'E',
        replace: true,
        require: "ngModel",
        scope: true,
        controllerAs: 'gsfCtrl',
        bindToController: {
            model: "=ngModel",
            onChange: "&"
        },
        template: `<div class="sm-group-scope__form">
                        <input type="text" ng-model="gsfCtrl.model.substring" ng-model-options="{ debounce: 250 }" class="form-control sm-panel-filter__item-input" ng-change="gsfCtrl.changeHandler()"/>
                        <div>
                            <sm-panel-radio-button-filter ng-model="gsfCtrl.model.isNull"
                                                  all-options="gsfCtrl.allScopeOptions" 
                                                  on-change="gsfCtrl.changeHandler()">
                            </sm-panel-radio-button-filter>
                        </div>
                    </div>`,
        controller: GroupScopeFilterController
    };
});

class GroupScopeFilterController {
    //binded
    model: IGroupScopeFilterModel;
    onChange: () => void;

    allScopeOptions: ISmPanelRadioButtonOption<boolean | null>[];

    constructor() {
        this.allScopeOptions = [
            {
                value: null,
                displayName: "All"
            },
            {
                value: false,
                displayName: "Non empty"
            },
            {
                value: true,
                displayName: "n/a"
            }
        ]
    }

    changeHandler() {
        if (this.onChange) {
            this.onChange();
        }
    }
}