'use strict';

import { register } from '@systemorph/web';
import { IScope } from 'angular';
import { Dictionary } from 'lodash';
import { IAccessControlService } from '../../accessControl.api';

register.directive("accessObjectModelView", () => {
    return {
        restrict: 'E',
        replace: true,
        scope: {
            model: "=",
            highlight: "="
        },
        template: `<a ng-href="{{::(model.id | detailsUrl)}}">
                        <span ng-if="groupScopeTypeInfosDictionary" class="sm-access-control-object__icon" ng-bind-html="::(model | accessObjectIconHtmlByModelInstance:groupScopeTypeInfosDictionary )"></span>
                        <span class="sm-access-control-object__label" ng-bind-html="::(model | propertiesToUpper | dimensionName | highlight: highlight)"></span>
                    </a>`,
        controller: ($scope: IScope, accessControlService: IAccessControlService) => {
            accessControlService.getAllGroupScopeTypeInfosDictionaryCached().then(dictionary => {
                $scope.groupScopeTypeInfosDictionary = dictionary;
            })
        }
    };
});