'use strict';

import { register } from '@systemorph/web';
import { IScope } from 'angular';
import { IAccessControlService } from '../../accessControl.api';
import { getGroupAssignmentLogActivityClass } from '../../utils';

interface IGroupAssignmentActivityViewScope extends IScope {
    activity: string;
    wordified: string;
    cssClass: string;
}

register.directive("groupAssignmentActivityView", () => {
    return {
        restrict: 'E',
        replace: true,
        scope: {
            activity: "=",
        },
        template: `<span ng-bind="wordified" ng-class="cssClass"></span>`,
        controller: ($scope: IGroupAssignmentActivityViewScope, accessControlService: IAccessControlService) => {
            accessControlService.getAllGroupAssignmentActivitiesDictionaryCached().then(dictionary => {
                $scope.wordified = dictionary[$scope.activity].displayName;
                $scope.cssClass = getGroupAssignmentLogActivityClass($scope.activity);
            })
        }
    };
});