'use strict';

import { register } from '@systemorph/web';
import { AC_ASSIGNMENT_STATUS } from "../../accessControl.constants";
import { IGroupAssignmentOfGroup } from "../../accessControl.api";
import { AC_COMMON_EVENT } from "../../accessControl.events";
import { IScope } from 'angular';

register.directive('groupAssignmentsList', () => {
    return {
        replace: true,
        restrict: 'E',
        scope: true,
        template: require('./groupAssignmentsList.html'),
        controller: GroupAssignmentsListController,
        controllerAs: 'galCtrl',
        bindToController: {
            highlightText: '=',
            assignments: '='
        }
    }
});

class GroupAssignmentsListController {
    // binded
    highlightText: boolean;
    assignments: IGroupAssignmentOfGroup[];

    readonly requestedStatus: string = AC_ASSIGNMENT_STATUS.requested;

    constructor(private $scope: IScope) {
    }
    
    onDeleteAssignment(assignment: IGroupAssignmentOfGroup) {
        this.$scope.$emit(AC_COMMON_EVENT.deleteGroupAssignment, assignment);
    }
}