'use strict';

import { register, IPersisterProviderService, ILayoutService, STATE } from '@systemorph/web';
import { AccessObjectGroupsControllerBase } from "./accessObjectGroupsControllerBase";
import { AC_ASSIGNMENT_TYPE, AC_DISPLAY_CONTEXT, AC_STATE } from "../../accessControl.constants";
import { IAccessControlService, IAccessControlDialogService } from "../../accessControl.api";
import { IScope, IFilterService, blockUI } from 'angular';
import { IStateParamsService } from 'angular-ui-router';

class AccessObjectMemberGroupsController extends AccessObjectGroupsControllerBase {
    /*@ngInject*/
    constructor(
        $scope: IScope,
        $stateParams: IStateParamsService,
        $filter: IFilterService,
        accessControlService: IAccessControlService,
        accessControlDialogService: IAccessControlDialogService,
        persisterProviderService: IPersisterProviderService,
        layoutService: ILayoutService,
        blockUI: blockUI.IBlockUIService
    ) {
        super($scope,
            $stateParams,
            $filter,
            accessControlService,
            accessControlDialogService,
            persisterProviderService,
            layoutService,
            blockUI,
            AC_ASSIGNMENT_TYPE.member,
            AC_DISPLAY_CONTEXT.accessObjectIsMemberOfGroups,
            `Member of Groups`);
    }
}

register.state({
    name: AC_STATE.accessObjectIsMemberOfGroups,
    parent: STATE.defaultLayout,
    url: '/memberOfGroups/:entityId',
    template: require('./accessObjectGroups.html'),
    controllerAs: 'pageCtrl',
    controller: AccessObjectMemberGroupsController,
    suppressReloadMessage: true
})