import { register } from '@systemorph/web';
import { IAccessObjectUiFriendlyModel, IGroupUiFriendlyModel } from "../accessControl.api";
import { getAccessObjectIconHtml } from "./helpers";
import { IGroupScopeTypeInfoModel } from "../accessControl.api";
import { Dictionary } from "lodash";

register.filter('accessObjectIconHtmlByModelInstance', () => {
    return (accessObject: IAccessObjectUiFriendlyModel | IGroupUiFriendlyModel, groupScopeTypeInfosDictionary: Dictionary<IGroupScopeTypeInfoModel>) => {
        if (!accessObject || !groupScopeTypeInfosDictionary) {
            return null;
        }
        const type = accessObject.typeName;

        return getAccessObjectIconHtml(type, (<IGroupUiFriendlyModel>accessObject).scopeType, groupScopeTypeInfosDictionary);
    };
});
