import { register, ISystemorphEntity } from '@systemorph/web';
import { getAccessObjectIconHtml } from "./helpers";
import { IGroupScopeTypeInfoModel } from "../accessControl.api";
import { Dictionary } from "lodash";

export interface IAccessObjectIconHtmlByOdataInstanceFilter {
    (accessObject: ISystemorphEntity, groupScopeTypeInfosDictionary: Dictionary<IGroupScopeTypeInfoModel>): string
}

register.filter('accessObjectIconHtmlByOdataInstance', () => {
    return (accessObject: ISystemorphEntity, groupScopeTypeInfosDictionary: Dictionary<IGroupScopeTypeInfoModel>) => {
        if (!accessObject || !groupScopeTypeInfosDictionary) {
            return null;
        }
        const type = (<any>accessObject.getType()).name;

        return getAccessObjectIconHtml(type, accessObject.ScopeType, groupScopeTypeInfosDictionary);
    };
});