'use strict';

import { ITypeLayout } from "@systemorph/web";
import { IPromise } from "angular";

export interface ILogOnModel {
    UserName?: string;
    Password?: string;
    ReturnUrl?: string;
    RememberMe?: boolean;
}

export interface IChangePasswordModel {
    OldPassword?: string;
    NewPassword?: string;
    ConfirmPassword?: string;
}

export interface IAccountResponse {
    success: boolean;
    error: string;
}

export interface ILogOnResponse extends IAccountResponse {
    userName: string;
}

export interface IAuthenticationData {
    isForms: boolean;
    logonStateName: string;
}

export interface IAccountService {
    getAuthenticationData(): IPromise<IAuthenticationData>;
    changePasswordLayout(): IPromise<ITypeLayout>;
    logOnLayout(): IPromise<ITypeLayout>;
    logonUser(model: ILogOnModel): IPromise<ILogOnResponse>;
    changePassword(model: IChangePasswordModel, returnUrl: string): IPromise<IAccountResponse>;
    initializePassword(id: string): IPromise<string>
} 