'use strict';

import { register, LINK_IMAGE_SIZES, DISPLAY_CONTEXT, STATE, IPropertyOfEntityScope} from '@systemorph/web';
import { IStateService } from 'angular-ui-router';

interface IAccessObjectImageUrlPropertyScope extends IPropertyOfEntityScope {
    url: string;
    imageUrl: string;
    defaultImageUrl: string;
    size: string;
}

register.directive('accessObjectImageUrlProperty', () => {
    return {
        restrict: 'E',
        replace: true,
        scope: true,
        template: `<div class="access-object-image-url-property-{{size}}">
                      <link-image image-url="imageUrl"
                                image-size="size"
                                default-image-url="defaultImageUrl"
                                url="url"
                                name="entity.DisplayName">
                      </link-image>
                  </div>`,
        controller: ($scope: IAccessObjectImageUrlPropertyScope, $state: IStateService) => {
            $scope.url = $state.href(STATE.details, { entityId: $scope.entity.Id}) ;
            $scope.imageUrl = $scope.entity[$scope.propertyLayout.systemName];
            $scope.defaultImageUrl = require("@systemorph/web/Content/images/default_user.png");
            $scope.size = $scope.displayContext === DISPLAY_CONTEXT.details
                ? LINK_IMAGE_SIZES.large
                : LINK_IMAGE_SIZES.inline;
        }
    };
});
