
import { STATE } from '@systemorph/web';
import * as angular from 'angular';
import { IStateService, IStateParamsService } from 'angular-ui-router';
import { AC_DISPLAY_CONTEXT, AC_STATE, AC_GROUP_ASSIGNMENT_MODE } from '../accessControl/accessControl.constants';

export const getUrlForGroupAssignments = ($state: IStateService, groupId: string, $stateParams: IStateParamsService, displayContext: string): string => {
    let userId: string;
    switch(displayContext) {
        case AC_DISPLAY_CONTEXT.accessObjectIsMemberOfGroups:
            userId = $stateParams['entityId']; // HACK as long as there is no better solution
            return $state.href(AC_STATE.groupMembers, { entityId: groupId, mode: AC_GROUP_ASSIGNMENT_MODE.direct, contextUserId: userId});
        case AC_DISPLAY_CONTEXT.accessObjectIsOwnerOfGroups:
            userId = $stateParams['entityId'];// HACK as long as there is no better solution
            return $state.href(AC_STATE.groupOwners, { entityId: groupId, mode: AC_GROUP_ASSIGNMENT_MODE.direct, contextUserId: userId });
        default:
            return $state.href(STATE.details, { entityId: groupId });
    }
}