'use strict';

import { register, IPropertyOfEntityScope, STATE } from '@systemorph/web';
import { IStateService, IStateParamsService } from "angular-ui-router";
import { getUrlForGroupAssignments } from "./assignmentsUrlGeneration.helpers";

register.directive('redirectToAssignmentsProperty', () => {
    return {
        restrict: 'E',
        replace: true,
        scope: true,
        controllerAs: "rgaCtrl",
        template: `<a class="details-string" href="{{::rgaCtrl.url}}" ng-bind="::rgaCtrl.name"></a>`,
        controller: RedirectToAssignmentsPropertyController
    };
});

class RedirectToAssignmentsPropertyController {
    url: string;
    name: string;

    constructor($scope: IPropertyOfEntityScope, $state: IStateService, $stateParams: IStateParamsService) {
        this.name = $scope.entity[$scope.propertyLayout.systemName];
        this.url = getUrlForGroupAssignments($state, $scope.entity.Id, $stateParams, $scope.displayContext);
    }
}
