'use strict';

import { register, IMessageService, IPropertyOfEntityScope } from '@systemorph/web';
import { IAccountService } from '../account/account.api';
import { IStateService } from 'angular-ui-router';

register.directive('resetPasswordProperty', () => {
    return {
        restrict: 'E',
        replace: true,
        scope: true,
        template: `<div>
                        <a ng-click="changePassword()" class="user-reset-password">Reset user password</a>                        
                    </div>`,
        controller: ($scope: IPropertyOfEntityScope, $state: IStateService, messageService: IMessageService, accountService: IAccountService) => {

            $scope.changePassword = () => {
                accountService.initializePassword($state.params.entityId)
                    .then(() => {
                        messageService.alertSuccess("User password has been reset");
                    })
                    .catch(error => {
                        messageService.alertError(error);
                    })
            };
        }
    };
});
