'use strict';

import { register, IPropertyOfEntityScope } from '@systemorph/web';
import { IStateService, IStateParamsService } from "angular-ui-router";
import { getUrlForGroupAssignments } from './assignmentsUrlGeneration.helpers';
import { IAccessControlService } from '../accessControl/accessControl.api';

register.directive('scopeTypeIconProperty', () => {
    return {
        restrict: 'E',
        replace: true,
        scope: true,
        controllerAs: "stiCtrl",
        template: `<a ng-href={{::stiCtrl.url}} 
                      class="details-string"
                      ng-bind-html="stiCtrl.iconHtml"
                      uib-tooltip="{{stiCtrl.tooltip}}" 
                      tooltip-append-to-body="true">
                  </a>`,
        controller: ScopeTypeImagePropertyController
    };
});

class ScopeTypeImagePropertyController {
    url: string;
    iconHtml: string;
    tooltip: string;

    constructor($scope: IPropertyOfEntityScope, $state: IStateService, $stateParams: IStateParamsService, accessControlService: IAccessControlService) {
        const value = ($scope.entity[$scope.propertyLayout.systemName] || '');
        this.url = getUrlForGroupAssignments($state, $scope.entity.Id, $stateParams, $scope.displayContext);

        accessControlService.getAllGroupScopeTypeInfosDictionaryCached()
            .then((dictionary) => {
                this.tooltip = dictionary[value].description;
                this.iconHtml = dictionary[value].iconHtml;
            })
    }
}
