'use strict';

import { register } from '@systemorph/web';
import { IScope } from 'angular';
import { IStateService } from 'angular-ui-router';

register.directive('accountMenuItem', () => {
    return {
        replace: true,
        restrict: 'E',
        template: require('./accountMenuItem.html'),
        transclude: true,
        controller: ($scope: IScope, $state: IStateService) => {
            $scope.imageUrl = $scope.item.parameters['userImageUrl'] || require('@systemorph/web/Content/images/default_user.png');
            if (!$scope.item.url && $scope.item.stateName) {
                $scope.item.url = $state.href($scope.item.stateName, $scope.item.stateParams, { inherit: false });
            }
        }
    };
});
