'use strict';

import { register, MENU_PROPERTY, IMenuItemScope, ISystemorphEntity } from '@systemorph/web';
import { IAccessControlDialogService } from '../accessControl/accessControl.api';

register.directive("pendingAccessReviewHeadingMenuItem", () => {
    return {
        restrict: 'E',
        replace: true,
        scope: true,
        template: `<button type="button" class="btn btn-inline btn-inline-static btn-success" ng-click="ctrl.completeReview()"
                      uib-tooltip="Complete review" tooltip-append-to-body="true">
                      <span class="glyphicon glyphicon-ok"></span
                   </button>`,
        controllerAs: "ctrl",
        controller: MenuController
    }
});

class MenuController {
    constructor(private $scope: IMenuItemScope, private accessControlDialogService: IAccessControlDialogService) {
    }

    completeReview() {
        const entity: ISystemorphEntity = this.$scope.item.parameters[MENU_PROPERTY.entity];
        this.accessControlDialogService.completeReview(entity.Id, entity["ReviewerComment"] || "");
    }
}
