'use strict';

import { register, ISystemorphEntity, IMenuItemScope, MENU_PROPERTY } from '@systemorph/web';
import { AC_STATE, AC_GROUP_ASSIGNMENT_MODE } from '../accessControl/accessControl.constants';
import { IStateService } from 'angular-ui-router';

register.directive("pendingAccessReviewTopMenuItem", () => {
    return {
        replace: true,
        scope: true,
        template: require('./pendingAccessReviewTop.html'),
        controllerAs: "ctrl",
        controller: MenuController
    }
});

class MenuController {
    membersUrl: string;
    ownersUrl: string;
    group: ISystemorphEntity;

    constructor($scope: IMenuItemScope, $state: IStateService) {
        const entity = <ISystemorphEntity> $scope.item.parameters[MENU_PROPERTY.entity];
        this.group = entity["Group"];
        this.membersUrl = $state.href(AC_STATE.groupMembers, { entityId: this.group.Id, mode: AC_GROUP_ASSIGNMENT_MODE.direct, reviewId: entity.Id});
        this.ownersUrl = $state.href(AC_STATE.groupOwners, { entityId: this.group.Id, mode: AC_GROUP_ASSIGNMENT_MODE.direct, reviewId: entity.Id });
    }
}